#include <vector>

class DefaultOperations
{
public:
    DefaultOperations() noexcept {} // No value initialization
    DefaultOperations(DefaultOperations const& rhs) :
        a{ rhs.a },
        b{ rhs.b }
    { }
    DefaultOperations& operator=(DefaultOperations const& rhs)
    {
        a = rhs.a;
        b = rhs.b;
        return *this;
    }
    DefaultOperations(DefaultOperations&& rhs) noexcept :
        a{ std::move(rhs.a) },
        b{ std::move(rhs.b) }
    { }
    DefaultOperations& operator=(DefaultOperations&& rhs) noexcept
    {
        a = std::move(rhs.a);
        b = std::move(rhs.b);
        return *this;
    }
    ~DefaultOperations() noexcept {}

private:
    int a;
    std::vector<int> b;
};
