#include <vector>

#pragma warning(push)
#pragma warning(disable: 4930)

class DefaultOperations
{
public:
    DefaultOperations           () /*noexcept(   )*/                             = default; // Default constructor
    DefaultOperations           (DefaultOperations const& rhs) /*noexcept(   )*/ = default; // Copy constructor
    //    : a{rhs.a},
    //      b{rhs.b}
    //{}
    DefaultOperations& operator=(DefaultOperations const& rhs) /*noexcept(   )*/ = default; // Copy assignment
    //{
    //    a = rhs.a;
    //    b = rhs.b;
    //    return *this;
    //}
    DefaultOperations           (DefaultOperations&& rhs) /*noexcept(   )*/      = default; // Move constructor
    //    : a{std::move(rhs.a)},
    //      b{std::move(rhs.b)}
    //{}
    DefaultOperations& operator=(DefaultOperations&& rhs) /*noexcept(   )*/      = default; // Move assignment
    //{
    //    a = std::move(rhs.a);
    //    b = std::move(rhs.b);
    //    return *this;
    //}
    ~DefaultOperations          () /*noexcept(   )*/                             = default; // Destructor
    //{}

private:
    int a;
    std::vector<int> b;
};

static void example()
{
    DefaultOperations a;          // default initialization
    DefaultOperations b{};        // value initialization (C++11)
    auto c = DefaultOperations(); // value initialization (pre C++11)
    DefaultOperations d();        // function declaration

    auto e{ a }; // copy constructor
    auto f = a;  // copy constructor
         f = a;  // copy assignment

    auto g{ std::move(a) }; // move constructor
    auto h = std::move(a);  // move constructor
         h = std::move(a);  // move assignment

    static_assert( std::is_nothrow_default_constructible_v<DefaultOperations>, "implicit noexcept(true)");
    static_assert(!std::is_nothrow_copy_constructible_v   <DefaultOperations>, "implicit noexcept(false)");
    static_assert(!std::is_nothrow_copy_assignable_v      <DefaultOperations>, "implicit noexcept(false)");
    static_assert( std::is_nothrow_move_constructible_v   <DefaultOperations>, "implicit noexcept(true)");
    static_assert( std::is_nothrow_move_assignable_v      <DefaultOperations>, "implicit noexcept(true)");
    static_assert( std::is_nothrow_destructible_v         <DefaultOperations>, "implicit noexcept(true)");
}

#pragma warning(pop)
