#include <utility>
#include <type_traits>

namespace
{

#define IS_LVALUE(EXPR)  ( std::is_lvalue_reference_v<decltype((EXPR))>)
#define IS_XVALUE(EXPR)  ( std::is_rvalue_reference_v<decltype((EXPR))>)
#define IS_PRVALUE(EXPR) (!std::is_reference_v       <decltype((EXPR))>)

struct IntWrapper { int value; };
float sum(int const a, float const& b) { return a + b; }
void example()
{
    int   x = 5;
    int&  y = x;
    int&& z = 5;

    static_assert(std::is_same_v<decltype( x )                  , int                        >);
    static_assert(std::is_same_v<decltype((x))                  , int&                       >);

    static_assert(std::is_same_v<decltype( 5 )                  , int                        >);
    static_assert(std::is_same_v<decltype((5))                  , int                        >);

    static_assert(std::is_same_v<decltype( y )                  , int&                       >);
    static_assert(std::is_same_v<decltype((y))                  , int&                       >);

    static_assert(std::is_same_v<decltype( z )                  , int&&                      >);
    static_assert(std::is_same_v<decltype((z))                  , int&                       >);

    static_assert(std::is_same_v<decltype( IntWrapper{5}.value ), int                        >);
    static_assert(std::is_same_v<decltype((IntWrapper{5}.value)), int&&                      >);

    static_assert(std::is_same_v<decltype( sum )                , float   (int, float const&)>);
    static_assert(std::is_same_v<decltype((sum))                , float(&)(int, float const&)>);
}

} // namespace
