#include <type_traits>

namespace
{

template <typename T>
constexpr std::remove_reference_t<T>&& move(T&& v) noexcept
{
    return static_cast<std::remove_reference_t<T>&&>(v);
}

template <typename T>
constexpr T&& forward(std::remove_reference_t<T>& v) noexcept
{
    return static_cast<T&&>(v);
}

template <typename T>
constexpr T&& forward(std::remove_reference_t<T>&& v) noexcept
{
    static_assert(!std::is_lvalue_reference_v<T>, "incorrect template parameter to T");
    return static_cast<T&&>(v);
}

} // namespace
