#pragma once

class BitArray
{
public:
    // Default ctor
    BitArray() = default;

    // TODO! Implement a copy constructor and assignment.
    //       Keep in mind all edge-cases:
    //       - Self-assignment
    //       - Throwing exceptions

    // TODO! Implement a move constructor and assignment
    //       Moved from object must be:
    //       - size == 0
    //       - have no allocation (bits_ == nullptr)

    ~BitArray() noexcept;

    // Creates a bit array with a particular size
    explicit BitArray(size_t size, bool default_value = false);

    void swap(BitArray&) noexcept;

    // Gets or sets a bit
    bool get(size_t index) const;
    void set(size_t index, bool value) const;

    size_t size() const noexcept { return size_; }

private:
    size_t size_ = 0;
    unsigned char* bits_ = nullptr;
};
inline void swap(BitArray& lhs, BitArray& rhs) noexcept
{
    lhs.swap(rhs);
}
