#pragma once

#include <stddef.h> // for size_t

namespace TestAllocator
{

// Use these allocation functions in this exercise
extern unsigned char* allocate(size_t size);
extern void deallocate(unsigned char* data);

extern void reset() noexcept;
extern void always_throw(bool value = true) noexcept;

extern size_t pending_allocations() noexcept;
extern size_t pending_bytes      () noexcept;
extern size_t total_allocations  () noexcept;
extern size_t total_bytes        () noexcept;

}
