function map(iterable, fn) {
    return Array.prototype.map.call(iterable, fn);
}
function filter(iterable, fn) {
    return Array.prototype.filter.call(iterable, fn);
}
function reduce(iterable, fn, initial_value) {
    return Array.prototype.reduce.call(iterable, fn, initial_value);
}
function http_get(url) {
    if (typeof BUNDLE_DATA !== 'undefined') {
        return new Promise(function (resolve, reject) {
            const data = BUNDLE_DATA[url];
            if (data) {
                resolve(data);
            }
            else {
                reject("file not found");
            }
        });
    }
    return new Promise(function (resolve, reject) {
        let xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.onload = (function () {
            if (this.status >= 200 && this.status < 300) {
                resolve(xhr.responseText);
            }
            else {
                reject({
                    status: this.status,
                    statusText: this.statusText
                });
            }
        });
        xhr.onerror = (function () {
            reject({
                status: this.status,
                statusText: this.statusText
            });
        });
        xhr.send();
    });
}
function parse_json(data) {
    return JSON.parse(data);
}
function memoize(fn) {
    let cache = {};
    return function (v) {
        let r = cache[v];
        if (r === undefined) {
            r = fn(v);
            cache[v] = r;
        }
        return r;
    };
}
function* regex_execs(regex, str) {
    while (true) {
        const match = regex.exec(str);
        if (!match) {
            regex.lastIndex = 0;
            return;
        }
        yield match;
    }
}
function assert(condition, message) {
    if (!condition) {
        throw Error(message);
    }
}
//# sourceMappingURL=util.js.map